class VColor:
    def __init__(self, rgb):
        self._rgb = rgb

    @property
    def rgb(self):
        return self._rgb

    def hexString(self):
        return "%0.2X%0.2X%0.2X" % self.rgb

    @property
    def r(self):
        return self._rgb[0]

    @property
    def g(self):
        return self._rgb[1]

    @property
    def b(self):
        return self._rgb[2]

    @staticmethod
    def distance(color1, color2):
        return (color1.r - color2.r)**2 + (color1.g - color2.g)**2 + (color1.b - color2.b)**2

    class tuple:
        @staticmethod
        def distance(color1, color2):
            return (color1[0] - color2[0])**2 + (color1[1] - color2[1])**2 + (color1[2] - color2[2])**2

class VGlobalColor:
    """This class defines colors according to the rgb palette"""
    transparent = None

    black = VColor(rgb=(0,0,0))

    darkred = VColor(rgb=(170,0,0))
    lightred = VColor(rgb=(255,0,0))
    red = darkred

    darkgreen = VColor(rgb=(0,170,0))
    lightgreen = VColor(rgb=(0,255,0))
    green = darkgreen

    darkblue = VColor(rgb=(0,0,170))
    lightblue = VColor(rgb=(0,0,255))
    blue = darkblue

    darkcyan = VColor(rgb=(0,170,170))
    lightcyan = VColor(rgb=(0,255,255))
    cyan = darkcyan

    darkmagenta = VColor(rgb=(170,0,170))
    lightmagenta = VColor(rgb=(255,0,255))
    magenta = darkmagenta

    yellow = VColor(rgb=(255,255,0))
    brown = VColor(rgb=(170,170,0))
    grey = VColor(rgb=(170,170,170))
    white = VColor(rgb=(255,255,255))

    term_0        = VColor(rgb=(0x00,0x00,0x00))
    term_1        = VColor(rgb=(0x80,0x00,0x00))
    term_2        = VColor(rgb=(0x00,0x80,0x00))
    term_3        = VColor(rgb=(0x80,0x80,0x00))
    term_4        = VColor(rgb=(0x00,0x00,0x80))
    term_5        = VColor(rgb=(0x80,0x00,0x80))
    term_6        = VColor(rgb=(0x00,0x80,0x80))
    term_6        = VColor(rgb=(0xc0,0xc0,0xc0))
    term_8        = VColor(rgb=(0x80,0x80,0x80))
    term_9        = VColor(rgb=(0xff,0x00,0x00))
    term_10       = VColor(rgb=(0x00,0xff,0x00))
    term_11       = VColor(rgb=(0xff,0xff,0x00))
    term_12       = VColor(rgb=(0x00,0x00,0xff))
    term_13       = VColor(rgb=(0xff,0x00,0xff))
    term_14       = VColor(rgb=(0x00,0xff,0xff))
    term_15       = VColor(rgb=(0xff,0xff,0xff))
    term_16       = VColor(rgb=(0x00,0x00,0x00))
    term_17       = VColor(rgb=(0x00,0x00,0x5f))
    term_18       = VColor(rgb=(0x00,0x00,0x87))
    term_19       = VColor(rgb=(0x00,0x00,0xaf))
    term_20       = VColor(rgb=(0x00,0x00,0xd7))
    term_21       = VColor(rgb=(0x00,0x00,0xff))
    term_22       = VColor(rgb=(0x00,0x5f,0x00))
    term_23       = VColor(rgb=(0x00,0x5f,0x5f))
    term_24       = VColor(rgb=(0x00,0x5f,0x87))
    term_25       = VColor(rgb=(0x00,0x5f,0xaf))
    term_26       = VColor(rgb=(0x00,0x5f,0xd7))
    term_27       = VColor(rgb=(0x00,0x5f,0xff))
    term_28       = VColor(rgb=(0x00,0x87,0x00))
    term_29       = VColor(rgb=(0x00,0x87,0x5f))
    term_30       = VColor(rgb=(0x00,0x87,0x87))
    term_31       = VColor(rgb=(0x00,0x87,0xaf))
    term_32       = VColor(rgb=(0x00,0x87,0xd7))
    term_33       = VColor(rgb=(0x00,0x87,0xff))
    term_34       = VColor(rgb=(0x00,0xaf,0x00))
    term_35       = VColor(rgb=(0x00,0xaf,0x5f))
    term_36       = VColor(rgb=(0x00,0xaf,0x87))
    term_37       = VColor(rgb=(0x00,0xaf,0xaf))
    term_38       = VColor(rgb=(0x00,0xaf,0xd7))
    term_39       = VColor(rgb=(0x00,0xaf,0xff))
    term_40       = VColor(rgb=(0x00,0xd7,0x00))
    term_41       = VColor(rgb=(0x00,0xd7,0x5f))
    term_42       = VColor(rgb=(0x00,0xd7,0x87))
    term_43       = VColor(rgb=(0x00,0xd7,0xaf))
    term_44       = VColor(rgb=(0x00,0xd7,0xd7))
    term_45       = VColor(rgb=(0x00,0xd7,0xff))
    term_46       = VColor(rgb=(0x00,0xff,0x00))
    term_47       = VColor(rgb=(0x00,0xff,0x5f))
    term_48       = VColor(rgb=(0x00,0xff,0x87))
    term_49       = VColor(rgb=(0x00,0xff,0xaf))
    term_50       = VColor(rgb=(0x00,0xff,0xd7))
    term_51       = VColor(rgb=(0x00,0xff,0xff))
    term_52       = VColor(rgb=(0x5f,0x00,0x00))
    term_53       = VColor(rgb=(0x5f,0x00,0x5f))
    term_54       = VColor(rgb=(0x5f,0x00,0x87))
    term_55       = VColor(rgb=(0x5f,0x00,0xaf))
    term_56       = VColor(rgb=(0x5f,0x00,0xd7))
    term_57       = VColor(rgb=(0x5f,0x00,0xff))
    term_58       = VColor(rgb=(0x5f,0x5f,0x00))
    term_59       = VColor(rgb=(0x5f,0x5f,0x5f))
    term_60       = VColor(rgb=(0x5f,0x5f,0x87))
    term_61       = VColor(rgb=(0x5f,0x5f,0xaf))
    term_62       = VColor(rgb=(0x5f,0x5f,0xd7))
    term_63       = VColor(rgb=(0x5f,0x5f,0xff))
    term_64       = VColor(rgb=(0x5f,0x87,0x00))
    term_65       = VColor(rgb=(0x5f,0x87,0x5f))
    term_66       = VColor(rgb=(0x5f,0x87,0x87))
    term_67       = VColor(rgb=(0x5f,0x87,0xaf))
    term_68       = VColor(rgb=(0x5f,0x87,0xd7))
    term_69       = VColor(rgb=(0x5f,0x87,0xff))
    term_70       = VColor(rgb=(0x5f,0xaf,0x00))
    term_71       = VColor(rgb=(0x5f,0xaf,0x5f))
    term_72       = VColor(rgb=(0x5f,0xaf,0x87))
    term_73       = VColor(rgb=(0x5f,0xaf,0xaf))
    term_74       = VColor(rgb=(0x5f,0xaf,0xd7))
    term_75       = VColor(rgb=(0x5f,0xaf,0xff))
    term_76       = VColor(rgb=(0x5f,0xd7,0x00))
    term_77       = VColor(rgb=(0x5f,0xd7,0x5f))
    term_78       = VColor(rgb=(0x5f,0xd7,0x87))
    term_79       = VColor(rgb=(0x5f,0xd7,0xaf))
    term_80       = VColor(rgb=(0x5f,0xd7,0xd7))
    term_81       = VColor(rgb=(0x5f,0xd7,0xff))
    term_82       = VColor(rgb=(0x5f,0xff,0x00))
    term_83       = VColor(rgb=(0x5f,0xff,0x5f))
    term_84       = VColor(rgb=(0x5f,0xff,0x87))
    term_85       = VColor(rgb=(0x5f,0xff,0xaf))
    term_86       = VColor(rgb=(0x5f,0xff,0xd7))
    term_87       = VColor(rgb=(0x5f,0xff,0xff))
    term_88       = VColor(rgb=(0x87,0x00,0x00))
    term_89       = VColor(rgb=(0x87,0x00,0x5f))
    term_90       = VColor(rgb=(0x87,0x00,0x87))
    term_91       = VColor(rgb=(0x87,0x00,0xaf))
    term_92       = VColor(rgb=(0x87,0x00,0xd7))
    term_93       = VColor(rgb=(0x87,0x00,0xff))
    term_94       = VColor(rgb=(0x87,0x5f,0x00))
    term_95       = VColor(rgb=(0x87,0x5f,0x5f))
    term_96       = VColor(rgb=(0x87,0x5f,0x87))
    term_97       = VColor(rgb=(0x87,0x5f,0xaf))
    term_98       = VColor(rgb=(0x87,0x5f,0xd7))
    term_99       = VColor(rgb=(0x87,0x5f,0xff))
    term_100      = VColor(rgb=(0x87,0x87,0x00))
    term_101      = VColor(rgb=(0x87,0x87,0x5f))
    term_102      = VColor(rgb=(0x87,0x87,0x87))
    term_103      = VColor(rgb=(0x87,0x87,0xaf))
    term_104      = VColor(rgb=(0x87,0x87,0xd7))
    term_105      = VColor(rgb=(0x87,0x87,0xff))
    term_106      = VColor(rgb=(0x87,0xaf,0x00))
    term_107      = VColor(rgb=(0x87,0xaf,0x5f))
    term_108      = VColor(rgb=(0x87,0xaf,0x87))
    term_109      = VColor(rgb=(0x87,0xaf,0xaf))
    term_110      = VColor(rgb=(0x87,0xaf,0xd7))
    term_111      = VColor(rgb=(0x87,0xaf,0xff))
    term_112      = VColor(rgb=(0x87,0xd7,0x00))
    term_113      = VColor(rgb=(0x87,0xd7,0x5f))
    term_114      = VColor(rgb=(0x87,0xd7,0x87))
    term_115      = VColor(rgb=(0x87,0xd7,0xaf))
    term_116      = VColor(rgb=(0x87,0xd7,0xd7))
    term_117      = VColor(rgb=(0x87,0xd7,0xff))
    term_118      = VColor(rgb=(0x87,0xff,0x00))
    term_119      = VColor(rgb=(0x87,0xff,0x5f))
    term_120      = VColor(rgb=(0x87,0xff,0x87))
    term_121      = VColor(rgb=(0x87,0xff,0xaf))
    term_122      = VColor(rgb=(0x87,0xff,0xd7))
    term_123      = VColor(rgb=(0x87,0xff,0xff))
    term_124      = VColor(rgb=(0xaf,0x00,0x00))
    term_125      = VColor(rgb=(0xaf,0x00,0x5f))
    term_126      = VColor(rgb=(0xaf,0x00,0x87))
    term_127      = VColor(rgb=(0xaf,0x00,0xaf))
    term_128      = VColor(rgb=(0xaf,0x00,0xd7))
    term_129      = VColor(rgb=(0xaf,0x00,0xff))
    term_130      = VColor(rgb=(0xaf,0x5f,0x00))
    term_131      = VColor(rgb=(0xaf,0x5f,0x5f))
    term_132      = VColor(rgb=(0xaf,0x5f,0x87))
    term_133      = VColor(rgb=(0xaf,0x5f,0xaf))
    term_134      = VColor(rgb=(0xaf,0x5f,0xd7))
    term_135      = VColor(rgb=(0xaf,0x5f,0xff))
    term_136      = VColor(rgb=(0xaf,0x87,0x00))
    term_137      = VColor(rgb=(0xaf,0x87,0x5f))
    term_138      = VColor(rgb=(0xaf,0x87,0x87))
    term_139      = VColor(rgb=(0xaf,0x87,0xaf))
    term_140      = VColor(rgb=(0xaf,0x87,0xd7))
    term_141      = VColor(rgb=(0xaf,0x87,0xff))
    term_142      = VColor(rgb=(0xaf,0xaf,0x00))
    term_143      = VColor(rgb=(0xaf,0xaf,0x5f))
    term_144      = VColor(rgb=(0xaf,0xaf,0x87))
    term_145      = VColor(rgb=(0xaf,0xaf,0xaf))
    term_146      = VColor(rgb=(0xaf,0xaf,0xd7))
    term_147      = VColor(rgb=(0xaf,0xaf,0xff))
    term_148      = VColor(rgb=(0xaf,0xd7,0x00))
    term_149      = VColor(rgb=(0xaf,0xd7,0x5f))
    term_150      = VColor(rgb=(0xaf,0xd7,0x87))
    term_151      = VColor(rgb=(0xaf,0xd7,0xaf))
    term_152      = VColor(rgb=(0xaf,0xd7,0xd7))
    term_153      = VColor(rgb=(0xaf,0xd7,0xff))
    term_154      = VColor(rgb=(0xaf,0xff,0x00))
    term_155      = VColor(rgb=(0xaf,0xff,0x5f))
    term_156      = VColor(rgb=(0xaf,0xff,0x87))
    term_157      = VColor(rgb=(0xaf,0xff,0xaf))
    term_158      = VColor(rgb=(0xaf,0xff,0xd7))
    term_159      = VColor(rgb=(0xaf,0xff,0xff))
    term_160      = VColor(rgb=(0xd7,0x00,0x00))
    term_161      = VColor(rgb=(0xd7,0x00,0x5f))
    term_162      = VColor(rgb=(0xd7,0x00,0x87))
    term_163      = VColor(rgb=(0xd7,0x00,0xaf))
    term_164      = VColor(rgb=(0xd7,0x00,0xd7))
    term_165      = VColor(rgb=(0xd7,0x00,0xff))
    term_166      = VColor(rgb=(0xd7,0x5f,0x00))
    term_167      = VColor(rgb=(0xd7,0x5f,0x5f))
    term_168      = VColor(rgb=(0xd7,0x5f,0x87))
    term_169      = VColor(rgb=(0xd7,0x5f,0xaf))
    term_170      = VColor(rgb=(0xd7,0x5f,0xd7))
    term_171      = VColor(rgb=(0xd7,0x5f,0xff))
    term_172      = VColor(rgb=(0xd7,0x87,0x00))
    term_173      = VColor(rgb=(0xd7,0x87,0x5f))
    term_174      = VColor(rgb=(0xd7,0x87,0x87))
    term_175      = VColor(rgb=(0xd7,0x87,0xaf))
    term_176      = VColor(rgb=(0xd7,0x87,0xd7))
    term_177      = VColor(rgb=(0xd7,0x87,0xff))
    term_178      = VColor(rgb=(0xd7,0xaf,0x00))
    term_179      = VColor(rgb=(0xd7,0xaf,0x5f))
    term_180      = VColor(rgb=(0xd7,0xaf,0x87))
    term_181      = VColor(rgb=(0xd7,0xaf,0xaf))
    term_182      = VColor(rgb=(0xd7,0xaf,0xd7))
    term_183      = VColor(rgb=(0xd7,0xaf,0xff))
    term_184      = VColor(rgb=(0xd7,0xd7,0x00))
    term_185      = VColor(rgb=(0xd7,0xd7,0x5f))
    term_186      = VColor(rgb=(0xd7,0xd7,0x87))
    term_187      = VColor(rgb=(0xd7,0xd7,0xaf))
    term_188      = VColor(rgb=(0xd7,0xd7,0xd7))
    term_189      = VColor(rgb=(0xd7,0xd7,0xff))
    term_190      = VColor(rgb=(0xd7,0xff,0x00))
    term_191      = VColor(rgb=(0xd7,0xff,0x5f))
    term_192      = VColor(rgb=(0xd7,0xff,0x87))
    term_193      = VColor(rgb=(0xd7,0xff,0xaf))
    term_194      = VColor(rgb=(0xd7,0xff,0xd7))
    term_195      = VColor(rgb=(0xd7,0xff,0xff))
    term_196      = VColor(rgb=(0xff,0x00,0x00))
    term_197      = VColor(rgb=(0xff,0x00,0x5f))
    term_198      = VColor(rgb=(0xff,0x00,0x87))
    term_199      = VColor(rgb=(0xff,0x00,0xaf))
    term_200      = VColor(rgb=(0xff,0x00,0xd7))
    term_201      = VColor(rgb=(0xff,0x00,0xff))
    term_202      = VColor(rgb=(0xff,0x5f,0x00))
    term_203      = VColor(rgb=(0xff,0x5f,0x5f))
    term_204      = VColor(rgb=(0xff,0x5f,0x87))
    term_205      = VColor(rgb=(0xff,0x5f,0xaf))
    term_206      = VColor(rgb=(0xff,0x5f,0xd7))
    term_207      = VColor(rgb=(0xff,0x5f,0xff))
    term_208      = VColor(rgb=(0xff,0x87,0x00))
    term_209      = VColor(rgb=(0xff,0x87,0x5f))
    term_210      = VColor(rgb=(0xff,0x87,0x87))
    term_211      = VColor(rgb=(0xff,0x87,0xaf))
    term_212      = VColor(rgb=(0xff,0x87,0xd7))
    term_213      = VColor(rgb=(0xff,0x87,0xff))
    term_214      = VColor(rgb=(0xff,0xaf,0x00))
    term_215      = VColor(rgb=(0xff,0xaf,0x5f))
    term_216      = VColor(rgb=(0xff,0xaf,0x87))
    term_217      = VColor(rgb=(0xff,0xaf,0xaf))
    term_218      = VColor(rgb=(0xff,0xaf,0xd7))
    term_219      = VColor(rgb=(0xff,0xaf,0xff))
    term_220      = VColor(rgb=(0xff,0xd7,0x00))
    term_221      = VColor(rgb=(0xff,0xd7,0x5f))
    term_222      = VColor(rgb=(0xff,0xd7,0x87))
    term_223      = VColor(rgb=(0xff,0xd7,0xaf))
    term_224      = VColor(rgb=(0xff,0xd7,0xd7))
    term_225      = VColor(rgb=(0xff,0xd7,0xff))
    term_226      = VColor(rgb=(0xff,0xff,0x00))
    term_227      = VColor(rgb=(0xff,0xff,0x5f))
    term_228      = VColor(rgb=(0xff,0xff,0x87))
    term_229      = VColor(rgb=(0xff,0xff,0xaf))
    term_230      = VColor(rgb=(0xff,0xff,0xd7))
    term_231      = VColor(rgb=(0xff,0xff,0xff))
    term_232      = VColor(rgb=(0x08,0x08,0x08))
    term_233      = VColor(rgb=(0x12,0x12,0x12))
    term_234      = VColor(rgb=(0x1c,0x1c,0x1c))
    term_235      = VColor(rgb=(0x26,0x26,0x26))
    term_236      = VColor(rgb=(0x30,0x30,0x30))
    term_237      = VColor(rgb=(0x3a,0x3a,0x3a))
    term_238      = VColor(rgb=(0x44,0x44,0x44))
    term_239      = VColor(rgb=(0x4e,0x4e,0x4e))
    term_240      = VColor(rgb=(0x58,0x58,0x58))
    term_241      = VColor(rgb=(0x60,0x60,0x60))
    term_242      = VColor(rgb=(0x66,0x66,0x66))
    term_243      = VColor(rgb=(0x76,0x76,0x76))
    term_244      = VColor(rgb=(0x80,0x80,0x80))
    term_245      = VColor(rgb=(0x8a,0x8a,0x8a))
    term_246      = VColor(rgb=(0x94,0x94,0x94))
    term_247      = VColor(rgb=(0x9e,0x9e,0x9e))
    term_248      = VColor(rgb=(0xa8,0xa8,0xa8))
    term_249      = VColor(rgb=(0xb2,0xb2,0xb2))
    term_250      = VColor(rgb=(0xbc,0xbc,0xbc))
    term_251      = VColor(rgb=(0xc6,0xc6,0xc6))
    term_252      = VColor(rgb=(0xd0,0xd0,0xd0))
    term_253      = VColor(rgb=(0xda,0xda,0xda))
    term_254      = VColor(rgb=(0xe4,0xe4,0xe4))
    term_255      = VColor(rgb=(0xee,0xee,0xee))
    pink = term_210

    @staticmethod
    def nameToColor(name):
        return VGlobalColor.__dict__.get(name)

